--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -3613,26 +4229,19 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // MaterialRetained methods
-    //
-
     @Override
     void updateMaterial(Context ctx,
-            float red, float green, float blue, float alpha,
-            float aRed, float aGreen, float aBlue,
-            float eRed, float eGreen, float eBlue,
-            float dRed, float dGreen, float dBlue,
-            float sRed, float sGreen, float sBlue,
-            float shininess, int colorTarget, boolean lightEnable) {
+                        float red, float green, float blue, float alpha,
+                        float aRed, float aGreen, float aBlue,
+                        float eRed, float eGreen, float eBlue,
+                        float dRed, float dGreen, float dBlue,
+                        float sRed, float sGreen, float sBlue,
+                        float shininess, int colorTarget, boolean lightEnable) {
         if (VERBOSE) System.err.println("JoglPipeline.updateMaterial()");
 
         float[] color = new float[4];
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         gl.glMaterialf(GL.GL_FRONT_AND_BACK, GL2.GL_SHININESS, shininess);
         switch (colorTarget) {
@@ -3653,19 +4262,29 @@
                 break;
         }
 
-        color[0] = eRed; color[1] = eGreen; color[2] = eBlue;
+        color[0] = eRed;
+        color[1] = eGreen;
+        color[2] = eBlue;
         gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL2.GL_EMISSION, color, 0);
 
-        color[0] = aRed; color[1] = aGreen; color[2] = aBlue;
+        color[0] = aRed;
+        color[1] = aGreen;
+        color[2] = aBlue;
         gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL2.GL_AMBIENT, color, 0);
 
-        color[0] = sRed; color[1] = sGreen; color[2] = sBlue;
+        color[0] = sRed;
+        color[1] = sGreen;
+        color[2] = sBlue;
         gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL2.GL_SPECULAR, color, 0);
 
         if (lightEnable) {
-            color[0] = dRed; color[1] = dGreen; color[2] = dBlue;
-        } else {
-            color[0] = red; color[1] = green; color[2] = blue;
+            color[0] = dRed;
+            color[1] = dGreen;
+            color[2] = dBlue;
+        } else {
+            color[0] = red;
+            color[1] = green;
+            color[2] = blue;
         }
         color[3] = alpha;
         gl.glMaterialfv(GL.GL_FRONT_AND_BACK, GL2.GL_DIFFUSE, color, 0);
@@ -3678,19 +4297,12 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // ModelClipRetained methods
-    //
-
     @Override
     void updateModelClip(Context ctx, int planeNum, boolean enableFlag,
-            double A, double B, double C, double D) {
+                         double A, double B, double C, double D) {
         if (VERBOSE) System.err.println("JoglPipeline.updateModelClip()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         double[] equation = new double[4];
         int pl = GL2.GL_CLIP_PLANE0 + planeNum;
@@ -3708,18 +4320,11 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // PointAttributesRetained methods
-    //
-
     @Override
     void updatePointAttributes(Context ctx, float pointSize, boolean pointAntialiasing) {
         if (VERBOSE) System.err.println("JoglPipeline.updatePointAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glPointSize(pointSize);
 
         // XXXX: Polygon Mode check, blend enable
@@ -3730,22 +4335,15 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // PolygonAttributesRetained methods
-    //
-
     @Override
     void updatePolygonAttributes(Context ctx,
-            int polygonMode, int cullFace,
-            boolean backFaceNormalFlip,
-            float polygonOffset,
-            float polygonOffsetFactor) {
+                                 int polygonMode, int cullFace,
+                                 boolean backFaceNormalFlip,
+                                 float polygonOffset,
+                                 float polygonOffsetFactor) {
         if (VERBOSE) System.err.println("JoglPipeline.updatePolygonAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (cullFace == PolygonAttributes.CULL_NONE) {
             gl.glDisable(GL.GL_CULL_FACE);
@@ -3799,30 +4397,23 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // RenderingAttributesRetained methods
-    //
-
     @Override
     void updateRenderingAttributes(Context ctx,
-            boolean depthBufferWriteEnableOverride,
-            boolean depthBufferEnableOverride,
-            boolean depthBufferEnable,
-            boolean depthBufferWriteEnable,
-            int depthTestFunction,
-            float alphaTestValue, int alphaTestFunction,
-            boolean ignoreVertexColors,
-            boolean rasterOpEnable, int rasterOp,
-            boolean userStencilAvailable, boolean stencilEnable,
-            int stencilFailOp, int stencilZFailOp, int stencilZPassOp,
-            int stencilFunction, int stencilReferenceValue,
-            int stencilCompareMask, int stencilWriteMask ) {
+                                   boolean depthBufferWriteEnableOverride,
+                                   boolean depthBufferEnableOverride,
+                                   boolean depthBufferEnable,
+                                   boolean depthBufferWriteEnable,
+                                   int depthTestFunction,
+                                   float alphaTestValue, int alphaTestFunction,
+                                   boolean ignoreVertexColors,
+                                   boolean rasterOpEnable, int rasterOp,
+                                   boolean userStencilAvailable, boolean stencilEnable,
+                                   int stencilFailOp, int stencilZFailOp, int stencilZPassOp,
+                                   int stencilFunction, int stencilReferenceValue,
+                                   int stencilCompareMask, int stencilWriteMask) {
         if (VERBOSE) System.err.println("JoglPipeline.updateRenderingAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (!depthBufferEnableOverride) {
             if (depthBufferEnable) {
@@ -3989,7 +4580,7 @@
     // ---------------------------------------------------------------------
 
     //
-    // TexCoordGenerationRetained methods
+    // TextureCubeMapRetained methods
     //
 
     /**
@@ -3999,15 +4590,15 @@
      */
     @Override
     void updateTexCoordGeneration(Context ctx,
-            boolean enable, int genMode, int format,
-            float planeSx, float planeSy, float planeSz, float planeSw,
-            float planeTx, float planeTy, float planeTz, float planeTw,
-            float planeRx, float planeRy, float planeRz, float planeRw,
-            float planeQx, float planeQy, float planeQz, float planeQw,
-            double[] vworldToEc) {
+                                  boolean enable, int genMode, int format,
+                                  float planeSx, float planeSy, float planeSz, float planeSw,
+                                  float planeTx, float planeTy, float planeTz, float planeTw,
+                                  float planeRx, float planeRy, float planeRz, float planeRw,
+                                  float planeQx, float planeQy, float planeQz, float planeQw,
+                                  double[] vworldToEc) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexCoordGeneration()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         float[] planeS = new float[4];
         float[] planeT = new float[4];
@@ -4029,18 +4620,28 @@
             }
 
             if (genMode != TexCoordGeneration.SPHERE_MAP) {
-                planeS[0] = planeSx; planeS[1] = planeSy;
-                planeS[2] = planeSz; planeS[3] = planeSw;
-                planeT[0] = planeTx; planeT[1] = planeTy;
-                planeT[2] = planeTz; planeT[3] = planeTw;
+                planeS[0] = planeSx;
+                planeS[1] = planeSy;
+                planeS[2] = planeSz;
+                planeS[3] = planeSw;
+                planeT[0] = planeTx;
+                planeT[1] = planeTy;
+                planeT[2] = planeTz;
+                planeT[3] = planeTw;
                 if (format == TexCoordGeneration.TEXTURE_COORDINATE_3) {
-                    planeR[0] = planeRx; planeR[1] = planeRy;
-                    planeR[2] = planeRz; planeR[3] = planeRw;
+                    planeR[0] = planeRx;
+                    planeR[1] = planeRy;
+                    planeR[2] = planeRz;
+                    planeR[3] = planeRw;
                 } else if (format == TexCoordGeneration.TEXTURE_COORDINATE_4) {
-                    planeR[0] = planeRx; planeR[1] = planeRy;
-                    planeR[2] = planeRz; planeR[3] = planeRw;
-                    planeQ[0] = planeQx; planeQ[1] = planeQy;
-                    planeQ[2] = planeQz; planeQ[3] = planeQw;
+                    planeR[0] = planeRx;
+                    planeR[1] = planeRy;
+                    planeR[2] = planeRz;
+                    planeR[3] = planeRw;
+                    planeQ[0] = planeQx;
+                    planeQ[1] = planeQy;
+                    planeQ[2] = planeQz;
+                    planeQ[3] = planeQw;
                 }
             }
 
@@ -4130,257 +4731,32 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // TransparencyAttributesRetained methods
-    //
-
-    private static final int screen_door[][] = {
-        /* 0 / 16 */
-        {
-            0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-                    0x00000000, 0x00000000, 0x00000000, 0x00000000,
-        },
-        /* 1 / 16 */
-        {
-            0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-                    0x00000000, 0x22222222, 0x00000000, 0x00000000,
-        },
-        /* 2 / 16 */
-        {
-            0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-                    0x00000000, 0x22222222, 0x00000000, 0x88888888,
-        },
-        /* 3 / 16 */
-        {
-            0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0x88888888,
-        },
-        /* 4 / 16 */
-        {
-            0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x00000000, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-        },
-        /* 5 / 16 */
-        {
-            0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x00000000, 0xaaaaaaaa,
-        },
-        /* 6 / 16 */
-        {
-            0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x11111111, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-        },
-        /* 7 / 16 */
-        {
-            0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x44444444, 0xaaaaaaaa,
-        },
-        /* 8 / 16 */
-        {
-            0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x55555555, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-        },
-        /* 9 / 16 */
-        {
-            0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0x55555555, 0xaaaaaaaa,
-        },
-        /* 10 / 16 */
-        {
-            0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0x77777777, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-        },
-        /* 11 / 16 */
-        {
-            0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xdddddddd, 0xaaaaaaaa,
-        },
-        /* 12 / 16 */
-        {
-            0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xaaaaaaaa, 0xffffffff, 0xaaaaaaaa,
-        },
-        /* 13 / 16 */
-        {
-            0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xaaaaaaaa,
-        },
-        /* 14 / 16 */
-        {
-            0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xbbbbbbbb, 0xffffffff, 0xeeeeeeee,
-        },
-        /* 15 / 16 */
-        {
-            0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xeeeeeeee,
-        },
-        /* 16 / 16 */
-        {
-            0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-                    0xffffffff, 0xffffffff, 0xffffffff, 0xffffffff,
-        },
-    };
-    private static final ByteBuffer[] screen_door_table = new ByteBuffer[screen_door.length];
-    static {
-		int eachLen = screen_door[0].length * Buffers.SIZEOF_INT;
-		ByteBuffer buf = Buffers.newDirectByteBuffer(screen_door.length * eachLen);
-        IntBuffer intBuf = buf.asIntBuffer();
-        for (int i = 0; i < screen_door.length; i++) {
-            intBuf.put(screen_door[i]);
-        }
-        buf.rewind();
-        for (int i = 0; i < screen_door.length; i++) {
-            buf.position(i * eachLen);
-            buf.limit((i+1) * eachLen);
-            screen_door_table[i] = buf.slice();
-        }
-    }
-
-    private static final int[] blendFunctionTable = new int[TransparencyAttributes.MAX_BLEND_FUNC_TABLE_SIZE];
-    static {
-        blendFunctionTable[TransparencyAttributes.BLEND_ZERO] = GL.GL_ZERO;
-        blendFunctionTable[TransparencyAttributes.BLEND_ONE] = GL.GL_ONE;
-        blendFunctionTable[TransparencyAttributes.BLEND_SRC_ALPHA] = GL.GL_SRC_ALPHA;
-        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_SRC_ALPHA] = GL.GL_ONE_MINUS_SRC_ALPHA;
-        blendFunctionTable[TransparencyAttributes.BLEND_DST_COLOR] = GL.GL_DST_COLOR;
-        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_DST_COLOR] = GL.GL_ONE_MINUS_DST_COLOR;
-        blendFunctionTable[TransparencyAttributes.BLEND_SRC_COLOR] = GL.GL_SRC_COLOR;
-        blendFunctionTable[TransparencyAttributes.BLEND_ONE_MINUS_SRC_COLOR] = GL.GL_ONE_MINUS_SRC_COLOR;
-        blendFunctionTable[TransparencyAttributes.BLEND_CONSTANT_COLOR] = GL2.GL_CONSTANT_COLOR;
-    }
-
     @Override
     void updateTransparencyAttributes(Context ctx,
-            float alpha, int geometryType,
-            int polygonMode,
-            boolean lineAA, boolean pointAA,
-            int transparencyMode,
-            int srcBlendFunction,
-            int dstBlendFunction) {
+                                      float alpha, int geometryType,
+                                      int polygonMode,
+                                      boolean lineAA, boolean pointAA,
+                                      int transparencyMode,
+                                      int srcBlendFunction,
+                                      int dstBlendFunction) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTransparencyAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (transparencyMode != TransparencyAttributes.SCREEN_DOOR) {
             gl.glDisable(GL2.GL_POLYGON_STIPPLE);
-        } else  {
+        } else {
             gl.glEnable(GL2.GL_POLYGON_STIPPLE);
-            gl.glPolygonStipple(screen_door_table[(int)(alpha * 16)]);
+            gl.glPolygonStipple(screen_door_table[(int) (alpha * 16)]);
         }
 
         if ((transparencyMode < TransparencyAttributes.SCREEN_DOOR) ||
                 ((((geometryType & RenderMolecule.LINE) != 0) ||
-                (polygonMode == PolygonAttributes.POLYGON_LINE))
-                && lineAA) ||
+                        (polygonMode == PolygonAttributes.POLYGON_LINE))
+                        && lineAA) ||
                 ((((geometryType & RenderMolecule.POINT) != 0) ||
-                (polygonMode == PolygonAttributes.POLYGON_POINT))
-                && pointAA)) {
+                        (polygonMode == PolygonAttributes.POLYGON_POINT))
+                        && pointAA)) {
             gl.glEnable(GL.GL_BLEND);
             // valid range of blendFunction 0..3 is already verified in shared code.
             gl.glBlendFunc(blendFunctionTable[srcBlendFunction], blendFunctionTable[dstBlendFunction]);
@@ -4389,25 +4765,18 @@
         }
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // TextureAttributesRetained methods
-    //
-
     @Override
     void updateTextureAttributes(Context ctx,
-            double[] transform, boolean isIdentity, int textureMode,
-            int perspCorrectionMode,
-            float textureBlendColorRed,
-            float textureBlendColorGreen,
-            float textureBlendColorBlue,
-            float textureBlendColorAlpha,
-            int textureFormat) {
+                                 double[] transform, boolean isIdentity, int textureMode,
+                                 int perspCorrectionMode,
+                                 float textureBlendColorRed,
+                                 float textureBlendColorGreen,
+                                 float textureBlendColorBlue,
+                                 float textureBlendColorAlpha,
+                                 int textureFormat) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureAttributes()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         gl.glHint(GL2.GL_PERSPECTIVE_CORRECTION_HINT,
                 (perspCorrectionMode == TextureAttributes.NICEST) ? GL.GL_NICEST : GL.GL_FASTEST);
 
@@ -4462,17 +4831,17 @@
 
     @Override
     void updateRegisterCombiners(Context absCtx,
-            double[] transform, boolean isIdentity, int textureMode,
-            int perspCorrectionMode,
-            float textureBlendColorRed,
-            float textureBlendColorGreen,
-            float textureBlendColorBlue,
-            float textureBlendColorAlpha,
-            int textureFormat,
-            int combineRgbMode, int combineAlphaMode,
-            int[] combineRgbSrc, int[] combineAlphaSrc,
-            int[] combineRgbFcn, int[] combineAlphaFcn,
-            int combineRgbScale, int combineAlphaScale) {
+                                 double[] transform, boolean isIdentity, int textureMode,
+                                 int perspCorrectionMode,
+                                 float textureBlendColorRed,
+                                 float textureBlendColorGreen,
+                                 float textureBlendColorBlue,
+                                 float textureBlendColorAlpha,
+                                 int textureFormat,
+                                 int combineRgbMode, int combineAlphaMode,
+                                 int[] combineRgbSrc, int[] combineAlphaSrc,
+                                 int[] combineRgbFcn, int[] combineAlphaFcn,
+                                 int combineRgbScale, int combineAlphaScale) {
 // FIXME: GL_NV_register_combiners
 //        if (VERBOSE) System.err.println("JoglPipeline.updateRegisterCombiners()");
 //
@@ -4676,8 +5045,8 @@
 
     @Override
     void updateTextureColorTable(Context ctx, int numComponents,
-            int colorTableSize,
-            int[] textureColorTable) {
+                                 int colorTableSize,
+                                 int[] textureColorTable) {
 // FIXME: GL_SGI_texture_color_table
 //        if (VERBOSE) System.err.println("JoglPipeline.updateTextureColorTable()");
 //
@@ -4696,13 +5065,13 @@
 
     @Override
     void updateCombiner(Context ctx,
-            int combineRgbMode, int combineAlphaMode,
-            int[] combineRgbSrc, int[] combineAlphaSrc,
-            int[] combineRgbFcn, int[] combineAlphaFcn,
-            int combineRgbScale, int combineAlphaScale) {
+                        int combineRgbMode, int combineAlphaMode,
+                        int[] combineRgbSrc, int[] combineAlphaSrc,
+                        int[] combineRgbFcn, int[] combineAlphaFcn,
+                        int combineRgbScale, int combineAlphaScale) {
         if (VERBOSE) System.err.println("JoglPipeline.updateCombiner()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
         int[] GLrgbMode = new int[1];
         int[] GLalphaMode = new int[1];
         getGLCombineMode(gl, combineRgbMode, combineAlphaMode,
@@ -4745,10 +5114,8 @@
         gl.glTexEnvi(GL2.GL_TEXTURE_ENV, GL2.GL_ALPHA_SCALE, combineAlphaScale);
     }
 
-    // Helper routines for above
-
     private void getGLCombineMode(GL gl, int combineRgbMode, int combineAlphaMode,
-            int[] GLrgbMode, int[] GLalphaMode) {
+                                  int[] GLrgbMode, int[] GLalphaMode) {
         switch (combineRgbMode) {
             case TextureAttributes.COMBINE_REPLACE:
                 GLrgbMode[0] = GL.GL_REPLACE;
@@ -4808,83 +5175,11 @@
         }
     }
 
-    // mapping from java enum to gl enum
-    private static final int[] _gl_combineRgbSrcIndex = {
-        GL2.GL_SOURCE0_RGB,
-        GL2.GL_SOURCE1_RGB,
-        GL2.GL_SOURCE2_RGB,
-    };
-
-    private static final int[] _gl_combineAlphaSrcIndex = {
-        GL2.GL_SOURCE0_ALPHA,
-        GL2.GL_SOURCE1_ALPHA,
-        GL2.GL_SOURCE2_ALPHA,
-    };
-
-    private static final int[] _gl_combineRgbOpIndex = {
-        GL2.GL_OPERAND0_RGB,
-        GL2.GL_OPERAND1_RGB,
-        GL2.GL_OPERAND2_RGB,
-    };
-
-    private static final int[] _gl_combineAlphaOpIndex = {
-        GL2.GL_OPERAND0_ALPHA,
-        GL2.GL_OPERAND1_ALPHA,
-        GL2.GL_OPERAND2_ALPHA,
-    };
-
-    private static final int[] _gl_combineSrc = {
-        GL2.GL_PRIMARY_COLOR,      // TextureAttributes.COMBINE_OBJECT_COLOR
-        GL.GL_TEXTURE,            // TextureAttributes.COMBINE_TEXTURE
-        GL2.GL_CONSTANT,           // TextureAttributes.COMBINE_CONSTANT_COLOR
-        GL2.GL_PREVIOUS,           // TextureAttributes.COMBINE_PREVIOUS_TEXTURE_UNIT_STATE
-    };
-
-    private static final int[] _gl_combineFcn = {
-        GL.GL_SRC_COLOR,              // TextureAttributes.COMBINE_SRC_COLOR
-        GL.GL_ONE_MINUS_SRC_COLOR,    // TextureAttributes.COMBINE_ONE_MINUS_SRC_COLOR
-        GL.GL_SRC_ALPHA,              // TextureAttributes.COMBINE_SRC_ALPHA
-        GL.GL_ONE_MINUS_SRC_ALPHA,    // TextureAttributes.COMBINE_ONE_MINUS_SRC_ALPHA
-    };
-
-// FIXME: GL_NV_register_combiners
-//    private int getCombinerArg(GL gl, int arg, int textureUnit, int combUnit) {
-//        int comb = 0;
-//
-//        switch (arg) {
-//            case TextureAttributes.COMBINE_OBJECT_COLOR:
-//                if (combUnit == GL.GL_COMBINER0_NV) {
-//                    comb = GL.GL_PRIMARY_COLOR_NV;
-//                } else {
-//                    comb = GL.GL_SPARE0_NV;
-//                }
-//                break;
-//            case TextureAttributes.COMBINE_TEXTURE_COLOR:
-//                comb = textureUnit;
-//                break;
-//            case TextureAttributes.COMBINE_CONSTANT_COLOR:
-//                comb = GL.GL_CONSTANT_COLOR0_NV;
-//                break;
-//            case TextureAttributes.COMBINE_PREVIOUS_TEXTURE_UNIT_STATE:
-//                comb = textureUnit -1;
-//                break;
-//        }
-//
-//        return comb;
-//    }
-
-
-    // ---------------------------------------------------------------------
-
-    //
-    // TextureUnitStateRetained methods
-    //
-
     @Override
     void updateTextureUnitState(Context ctx, int index, boolean enable) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureUnitState()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         if (index >= 0 && gl.isExtensionAvailable("GL_VERSION_1_3")) {
             gl.glActiveTexture(index + GL.GL_TEXTURE0);
